// Name
// Student ID

// The number of bars in the graph -- 20 age ranges from 0 to 100
// in steps of 5, and a final "100+" slice.
int num_bars = 21;

// The largest population in any bar for any year.  (Actually a bit
// larger than the real max, but at least no bar will end up 
// off-screen.)
int largest_bar = 1500000;

// Some constants to control the rendering of the
// bar graphs
float margin = 30.0;
float top_margin = 50.0;
float max_bar_width = 275;
float bar_height = (400-margin-top_margin)/num_bars;
float chart_height = num_bars * bar_height;

// A table to hold all population data.
Table pop;

// A helpful Dictionary that maps the name of an age range
// (e.g., "15 to 19 years") to the y location in the sketch
// window where the bar should be drawn.
FloatDict age_range_map;

// The year we're currently rendering
int current_year = 2000;

void setup()
{
  size( 600, 400 );
  pop = loadTable( "00510001-eng.csv", "header" );

  // Build a mapping from the age ranges we care about,
  // as they appear in the provided CSV file (e.g., "15 to 19 years")
  // to their corresponding y locations in the bar charts we're drawing.
  // This is much nicer than having to "parse" one of these age ranges
  // every time we see it.
  age_range_map = new FloatDict();

  for ( int idx = 0; idx < 20; ++idx ) {
    age_range_map.set( "" + (idx*5) + " to " + (idx*5+4) + " years", 
      chart_height - (idx+1)*bar_height );
  }
  age_range_map.set( "100 years and over", 
    chart_height - 21*bar_height );
}

// A helper function to draw one of the graphs.  Use
// geometric contexts so that we can call this twice:
// once with the male data, once with female.  Pass in
// "Males" or "Females" as the argument, to match up 
// with the contents of the "SEX" field in the table.
void drawChart( String sex )
{
  // TODO
}

void draw()
{
  background( 240 );

  textAlign( CENTER );
  fill( 0 );

  // Write the current year at the top of the sketch.
  // TODO

  // Write all the age range labels between the bar graphs
  // TODO

  // Draw the female bar graph.
  // TODO

  // Draw the male bar graph.
  // TODO
}

void keyPressed()
{
  if ( keyCode == LEFT ) {
    current_year = max( current_year - 1, 1971 );
  } else if ( keyCode == RIGHT ) {
    current_year = min( current_year + 1, 2016 );
  }
}